%define pkgversion 3.3.0.6246
%{!?disttag: %{expand: %%define disttag %%(. %%{_topdir}/SOURCES/sfc-disttag; echo -n $(sfc_disttag))}}
%{!?kernel:  %{expand: %%define kernel %%(uname -r)}}
%{!?kpath: %{expand: %%define kpath /lib/modules/%%{kernel}/build}}

%{!?sfc_config: %{expand: %%define sfc_config NDEBUG=1}}
%{?sfc_minimal: %{expand: %%define sfc_config %{sfc_config} CONFIG_SFC_DEBUGFS= CONFIG_SFC_HWMON= CONFIG_SFC_I2C= CONFIG_SFC_MTD= CONFIG_SFC_SFE4001= CONFIG_SFC_PRIVATE_MDIO=y}}

%define redhat     %(! [ "%{_vendor}" = "redhat" ] ; echo $?)
%define suse       %(! [ "%{_vendor}" = "suse"   ] ; echo $?)

Name:           sfc
Version:        %{pkgversion}
Release:        1
Epoch:          0

Summary:        Solarflare SFC4000/SFC9000-family network controller device driver

Group:          System Environment/Kernel
License:        GPL
URL:            http://www.solarflare.com/
Vendor:		Solarflare Communications

Source0:        %{name}-%{version}.tar.gz
Source1:        %{name}-disttag

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i386 i586 i686 x86_64 athlon ia64 ppc64
BuildRequires:  binutils, gcc, make

%description
The Linux kernel driver for Solarflare SFC4000 and SFC9000-family 10G
Ethernet controllers.

This builds a single RPM for a specific kernel version on any
supported Linux distribution.

The drivers contained in this package support the following Solarflare 
reference designs:
%{!?sfc_minimal: - Solarstorm SFE4001 10GBASE-T Server Adapter}
 - Solarstorm SFE4002 XFP Server Adapter
 - Solarstorm SFN4112F SFP+ Server Adapter
 - Solarstorm SFN5122F Dual Port SFP+ Server Adapter
 - Solarstorm SFN5121T Dual Port 10GBASE-T Server Adapter
 - Solarstorm SFN5151T 10GBASE-T Value Adapter
 - Solarstorm SFN5152F SFP+ Value Adapter
 - Solarstorm SFN5161T Dual Port 10GBASE-T Value Adapter
 - Solarstorm SFN5162F Dual Port SFP+ Value Adapter

%define binary_name kernel-module-%{name}-%{disttag}-%{kernel}
	
%package -n %{binary_name}
Summary:        %{summary}
Group:          %{group}

%description -n %{binary_name}
The Linux kernel driver for Solarflare SFC4000 and SFC9000-family 10G
Ethernet controllers.

The drivers contained in this package support the following Solarflare 
reference designs:
%{!?sfc_minimal: - Solarstorm SFE4001 10GBASE-T Server Adapter}
 - Solarstorm SFE4002 XFP Server Adapter
 - Solarstorm SFN4112F SFP+ Server Adapter
 - Solarstorm SFN5122F Dual Port SFP+ Server Adapter
 - Solarstorm SFN5121T Dual Port 10GBASE-T Server Adapter
 - Solarstorm SFN5151T 10GBASE-T Value Adapter
 - Solarstorm SFN5152F SFP+ Value Adapter
 - Solarstorm SFN5161T Dual Port 10GBASE-T Value Adapter
 - Solarstorm SFN5162F Dual Port SFP+ Value Adapter

# Inhibit debuginfo package
%define debug_package %{nil}

# -----------------------------------------------------------------------------

%prep
%setup -q

# -----------------------------------------------------------------------------

%build

%if %{suse}
  krel="kernel-"$(uname -r | awk -F'-' '{print $3;}')
  (rpm -qi $krel 2>&1 > /dev/null) && (rpm --verify $krel || echo >&2 -e "\n\nWARNING: /boot/sym* might not be for this kernel. This may cause ksym dependancy errors on RPM install\n\n")
%endif

[ -d "%{kpath}" ] || {
  set +x
  echo >&2 "ERROR: Kernel headers not found.  They should be at:"
  echo >&2 "ERROR:   %{kpath}"
%if %{redhat}
  echo >&2 "Hint: Install the $(echo '%{kernel}' | sed -r 's/(.*)(smp|hugemem|largesmp|PAE|xen)$/kernel-\2-devel-\1/; t; s/^/kernel-devel-/') package"
%endif
%if %{suse}
  echo >&2 "Hint: Install the kernel-source-$(echo '%kernel}' | sed -r 's/-[^-]*$//') package"
%endif
  exit 1
}

cd $RPM_BUILD_DIR/%{name}-%{version}
pushd linux_net

# do the build
%{__make} -j4 KVER=%{kernel} KPATH="%{kpath}" %{sfc_config} modules
popd

# -----------------------------------------------------------------------------

%install

%{__rm} -rf "$RPM_BUILD_ROOT"
cd "$RPM_BUILD_DIR/%{name}-%{version}"
pushd linux_net

# do the install
%{__make} INSTALL_MOD_PATH="${RPM_BUILD_ROOT}" KVER=%{kernel} \
  KPATH="%{kpath}" %{sfc_config} modules_install
popd

# rpm will complain about these files generated by depmod
rm -f ${RPM_BUILD_ROOT}/lib/modules/%{kernel}/modules.*

# -----------------------------------------------------------------------------

%clean
%{__rm} -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%post -n %{binary_name}
/sbin/depmod -a %{kernel}
if [ "$(uname -r)" = "%{kernel}" ]; then
    if [ -x /etc/hotplug/pci.rc ]; then
        /etc/hotplug/pci.rc start >/dev/null
    fi
    modprobe sfc
fi
true

%preun -n %{binary_name}
[ "$(uname -r)" = "%{kernel}" ] && \
  rmmod sfc &>/dev/null
true

%postun -n %{binary_name}
/sbin/depmod -a %{kernel}
true

# -----------------------------------------------------------------------------

%files -n %{binary_name}
%defattr(-,root,root,-)

/lib/modules/%{kernel}/*/*
